"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isFunction_1 = require("./isFunction");
function curry(fn) {
    if (!isFunction_1.default(fn))
        throw Error("Function not provided");
    var slice = Array.prototype.slice;
    var arity = fn.length;
    return function curried() {
        var args = slice.call(arguments, 0);
        if (args.length >= arity)
            return fn.apply(null, args);
        return function () {
            return curried.apply(null, args.concat(slice.call(arguments)));
        };
    };
}
exports.default = curry;
