"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var curry_1 = require("./curry");
var isFunction_1 = require("./isFunction");
function liftAn(f, fns) {
    if (!isFunction_1.default(f))
        throw Error("Expected a function");
    var init = fns[0].map(f);
    var res = init;
    if (fns.length > 1) {
        var rest = fns.slice(1);
        res = rest.reduce(function applyFn(a, ca) {
            return a.ap(ca);
        }, init);
    }
    return res;
}
exports.default = curry_1.default(liftAn);
