"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isFunction_1 = require("./isFunction");
function once(f) {
    if (!isFunction_1.default(f))
        throw Error("Function not provided");
    var _called = false;
    var _result;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!_called) {
            _called = true;
            _result = f.apply(null, args);
        }
        return _result;
    };
}
exports.default = once;
